SoPerspectiveCamera(3)

NAME
SoPerspectiveCamera - The SoPerspectiveCamera class defines a camera node with perspective rendering.

SYNOPSIS

#include <Inventor/nodes/SoPerspectiveCamera.h>

Inherits SoCamera.

Inherited by SoReversePerspectiveCamera.

  Public Member Functions
virtual SoType getTypeId (void) const
SoPerspectiveCamera (void)
virtual void scaleHeight (float scalefactor)
virtual SbViewVolume getViewVolume (float useaspectratio=0.0f) const
virtual void viewBoundingBox (const SbBox3f &box, float aspect, float slack)

  Static Public Member Functions
static SoType getClassTypeId (void)
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.

  Public Attributes
SoSFFloat heightAngle

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual ~SoPerspectiveCamera ()

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)

  Additional Inherited Members

Detailed Description

The SoPerspectiveCamera class defines a camera node with perspective rendering. For realistic looking 3D scene, the geometry should be rendered with perspective calculations. Use this camera type to accomplish this.

FILE FORMAT/DEFAULTS:

PerspectiveCamera {
    viewportMapping ADJUST_CAMERA
    position 0 0 1
    orientation 0 0 1  0
    nearDistance 1
    farDistance 10
    aspectRatio 1
    focalDistance 5
    heightAngle 0.78539819
}

Constructor & Destructor Documentation

  SoPerspectiveCamera::SoPerspectiveCamera (void)
Constructor.

  SoPerspectiveCamera::~SoPerspectiveCamera () [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoPerspectiveCamera::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoPerspectiveCamera::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.

Reimplemented from SoCamera.

Reimplemented in SoReversePerspectiveCamera.

  const SoFieldData ** SoPerspectiveCamera::getFieldDataPtr (void) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoPerspectiveCamera::getFieldData (void) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoCamera.

Reimplemented in SoReversePerspectiveCamera.

  void SoPerspectiveCamera::scaleHeight (float scalefactor) [virtual]
Scale the SoPerspectiveCamera::heightAngle field by multiplying with scalefactor.

Implements SoCamera.

  SbViewVolume SoPerspectiveCamera::getViewVolume (float useaspectratio = 0.0f) const [virtual]
Returns total view volume covered by the camera under the current settings.

This view volume is not adjusted to account for viewport mapping. If you want the same view volume as the one used during rendering, you should use getViewVolume(SbViewportRegion & vp, const SbMatrix & mm), or do something like this:

SbViewVolume vv;
float aspectratio = myviewport.getViewportAspectRatio();
switch (camera->viewportMapping.getValue()) {
case SoCamera::CROP_VIEWPORT_FILL_FRAME:
case SoCamera::CROP_VIEWPORT_LINE_FRAME:
case SoCamera::CROP_VIEWPORT_NO_FRAME:
  vv = camera->getViewVolume(0.0f);
  break;
case SoCamera::ADJUST_CAMERA:
  vv = camera->getViewVolume(aspectratio);
  if (aspectratio < 1.0f) vv.scale(1.0f / aspectratio);
  break;
case SoCamera::LEAVE_ALONE:
  vv = camera->getViewVolume(0.0f);
  break;
default:
  assert(0 && 'unknown viewport mapping');
  break;
}.fi

Also, for the CROPPED viewport mappings, the viewport might be changed if the viewport aspect ratio is not equal to the camera aspect ratio. See the SoCamera::getView() source-code (private method) to see how this is done.

Implements SoCamera.

  void SoPerspectiveCamera::viewBoundingBox (const SbBox3f & box, float aspect, float slack) [virtual]
Convenience method for setting up the camera definition to cover the given bounding box with the given aspect ratio. Multiplies the exact dimensions with a slack factor to have some space between the rendered model and the borders of the rendering area.

If you define your own camera node class, be aware that this method should not set the orientation field of the camera, only the position, focal distance and near and far clipping planes.

Implements SoCamera.

Member Data Documentation

  SoSFFloat SoPerspectiveCamera::heightAngle
The vertical angle of the viewport, also known as 'field of view'. Default value is 45 degrees (note: value is specified in radians).

Author

Generated automatically by Doxygen for Coin from the source code.